package com.example.ueberwachungssystem;

import static android.Manifest.permission.INTERNET;
import static android.Manifest.permission.CAMERA;
import static android.Manifest.permission.RECORD_AUDIO;

import android.content.pm.PackageManager;
import android.os.Handler;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;

public class PermissionRequest extends AppCompatActivity{
    private static final int PERMISSION_REQUEST_CODE = 123;
    private final MainActivity mainActivity;

    Handler handler = new Handler();

    public PermissionRequest(MainActivity mainActivity) {
        this.mainActivity = mainActivity;
    }

    public StringBuilder rechtePruefen() {
        boolean rechtKamera = ContextCompat.checkSelfPermission(mainActivity, CAMERA) == PackageManager.PERMISSION_GRANTED;
        boolean rechtMikrofon = ContextCompat.checkSelfPermission(mainActivity, RECORD_AUDIO) == PackageManager.PERMISSION_GRANTED;
        boolean rechtInternet = ContextCompat.checkSelfPermission(mainActivity, INTERNET) == PackageManager.PERMISSION_GRANTED;
        StringBuilder sb = new StringBuilder();
        sb.append("Rechte prüfen:")
                .append("\nKamera: ").append(rechtKamera)
                .append("\nMikrofon: ").append(rechtMikrofon)
                .append("\nInternet: ").append(rechtInternet);
        //mainActivity.runOnUiThread(() -> mainActivity.tvMessages.setText(sb));
        if (!(rechtKamera && rechtMikrofon && rechtInternet)){
            handler.post(new Runnable() {
                @Override
                public void run() {
                    Toast.makeText(mainActivity.getApplicationContext(),"Es werden Rechte benötigt", Toast.LENGTH_LONG).show();
                }
            });
        }
        return sb;
    }

    public void rechteAnfordern() {
        mainActivity.requestPermissions(new String[]{CAMERA, RECORD_AUDIO, INTERNET}, PERMISSION_REQUEST_CODE);
    }
}
